#
# Conditional build:
%bcond_without	ocaml_opt		# build opt
%bcond_without	tk			# build without tk support

%ifnarch %{ix86} %{x8664} %{arm} aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

Summary:	OCaml module manager
Summary(pl.UTF-8):	Zarządca modułów OCamla
Name:		ocaml-findlib
Version:	1.9.3
Release:	1%{?tld}
License:	distributable
Group:		Development/Tools
Source0:	http://download.camlcity.org/download/findlib-%{version}.tar.gz
# Source0-md5:	24047dd8a0da5322253de9b7aa254e42
URL:		http://projects.camlcity.org/projects/findlib.html
BuildRequires:	m4
BuildRequires:	ncurses-devel
BuildRequires:	ocaml >= 1:4.04
BuildRequires:	ocaml-camlp4
%{?with_tk:BuildRequires:	ocaml-labltk-devel}
BuildRequires:	ocaml-ocamldoc-devel
BuildRequires:	sed >= 4.0
%requires_eq	ocaml
Conflicts:	ocaml-curses < 1.0.3-13
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%if %{without ocaml_opt}
%define		no_install_post_strip	1
# debug package strips binaries which renders ocamlfind broken
%define		_enable_debug_packages	0
%endif

%description
The "findlib" library provides a scheme to manage reusable software
components (packages), and includes tools that support this scheme.
Packages are collections of OCaml modules for which metainformation
can be stored.

%description -l pl.UTF-8
Biblioteka "findlib" udostępnia metodę zarządzania komponentami
oprogramowania (pakietami) oraz zawiera narzędzia, które ową metodę
wspierają. Pakiety są kolekcjami modułów w OCamlu, dla których mogą
być przechowywane metainformacje.

%package devel
Summary:	OCaml module manager
Summary(pl.UTF-8):	Zarządca modułów OCamla
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
The "findlib" library provides a scheme to manage reusable software
components (packages), and includes tools that support this scheme.
Packages are collections of OCaml modules for which metainformation
can be stored.

This package includes libraries and compiled interfaces of findlib.

%description devel -l pl.UTF-8
Biblioteka "findlib" udostępnia metodę zarządzania komponentami
oprogramowania (pakietami) oraz zawiera narzędzia, które ową metodę
wspierają. Pakiety są kolekcjami modułów w OCamlu, dla których mogą
być przechowywane metainformacje.

Ten pakiet zawiera biblioteki i skompilowane interfejsy findliba.

%prep
%setup -q -n findlib-%{version}

%build
./configure \
	-bindir %{_bindir} \
	-mandir %{_mandir} \
	-config %{_sysconfdir}/ocamlfind.conf \
	-sitelib %{_libdir}/ocaml \
	-with-toolbox

sed -i -e 's/-g//' Makefile

%{__make} -j1 all %{?with_ocaml_opt:opt}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	prefix=$RPM_BUILD_ROOT

%{__rm} $RPM_BUILD_ROOT%{_libdir}/ocaml/findlib/*.mli

# now provided by ocaml-dbm.spec (might not exist if building without ocaml-dbm installed)
%{__rm} -rf $RPM_BUILD_ROOT%{_libdir}/ocaml/dbm
# now provided by ocaml-labltk.spec (might not exist if building without ocaml-labltk installed)
%{__rm} -rf $RPM_BUILD_ROOT%{_libdir}/ocaml/labltk
# now provided by ocaml-ocamlbuild.spec (might not exist if building without ocaml-ocamlbuild installed)
%{__rm} -rf $RPM_BUILD_ROOT%{_libdir}/ocaml/ocamlbuild

ln -sf topfind $RPM_BUILD_ROOT%{_libdir}/ocaml/ocamlfind

echo 'ldconf = "ignore"' >> $RPM_BUILD_ROOT%{_sysconfdir}/ocamlfind.conf

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc doc/README LICENSE doc/*-html
%attr(755,root,root) %{_bindir}/ocamlfind
%attr(755,root,root) %{_bindir}/safe_camlp4
%config %{_sysconfdir}/ocamlfind.conf
%dir %{_libdir}/ocaml/findlib
%if %{with tk}
%attr(755,root,root) %{_libdir}/ocaml/findlib/make_wizard
%{_libdir}/ocaml/findlib/make_wizard.pattern
%endif
%{_libdir}/ocaml/findlib/META
%{_libdir}/ocaml/findlib/Makefile.config
%{_libdir}/ocaml/findlib/Makefile.packages
%{_libdir}/ocaml/findlib/findlib.cma
%{_libdir}/ocaml/findlib/findlib_dynload.cma
%{_libdir}/ocaml/findlib/findlib_top.cma
%if %{with ocaml_opt}
%attr(755,root,root) %{_libdir}/ocaml/findlib/findlib.cmxs
%attr(755,root,root) %{_libdir}/ocaml/findlib/findlib_dynload.cmxs
%attr(755,root,root) %{_libdir}/ocaml/findlib/findlib_top.cmxs
%endif
# META files for base ocaml packages
%{_libdir}/ocaml/bigarray
%{_libdir}/ocaml/bytes
%{_libdir}/ocaml/compiler-libs
%{_libdir}/ocaml/dynlink
%{_libdir}/ocaml/ocamldoc
%{_libdir}/ocaml/stdlib
%{_libdir}/ocaml/str
%{_libdir}/ocaml/threads
%{_libdir}/ocaml/unix
# camlp4 4.02 doesn't provide its META itself
%{_libdir}/ocaml/camlp4
%{_mandir}/man1/ocamlfind.1*
%{_mandir}/man5/META.5*
%{_mandir}/man5/findlib.conf.5*
%{_mandir}/man5/site-lib.5*

%files devel
%defattr(644,root,root,755)
%{_libdir}/ocaml/findlib/findlib.cmi
%{_libdir}/ocaml/findlib/findlib_config.cmi
%{_libdir}/ocaml/findlib/findlib_config.ml
%{_libdir}/ocaml/findlib/fl_*.cmi
%{_libdir}/ocaml/findlib/ocaml_args.cmi
%{_libdir}/ocaml/findlib/topfind.cmi
%if %{with ocaml_opt}
%{_libdir}/ocaml/findlib/findlib.a
%{_libdir}/ocaml/findlib/findlib.cmxa
%{_libdir}/ocaml/findlib/findlib_dynload.a
%{_libdir}/ocaml/findlib/findlib_dynload.cmxa
%{_libdir}/ocaml/findlib/findlib_top.a
%{_libdir}/ocaml/findlib/findlib_top.cmxa
%endif
%{_libdir}/ocaml/ocamlfind
%{_libdir}/ocaml/topfind
%changelog
* Thu Jul 13 2023 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/ocaml-findlib.git;a=log;h=47c5e4b50ab7372dfc221aae6da4a98bdbb3dff1

* Sat Jan 29 2022 Jakub Bogusz <qboosh@pld-linux.org> 47c5e4b
- updated to 1.9.3
- removed obsolete labltk patch

* Sun Nov 21 2021 Jan Rękorajski <baggins@pld-linux.org> 0db4071
- there is no graphics package with ocaml 4.09+, rel 5

* Sun Nov 21 2021 Jan Rękorajski <baggins@pld-linux.org> ef2c4a1
- Release 4 (by relup.sh)

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> cb91a67
- rebuild with separate debuginfo build-ids

* Fri Sep 10 2021 Jakub Bogusz <qboosh@pld-linux.org> e72d91e
- fixed duplicate files
- check-files cleanup wrt. graphics package

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> 73a8c38
- drop separate site-lib only for META files, this is causing mess and
  issues with other build systems line dune or opam
- rel 2

* Thu Mar 18 2021 Jan Rękorajski <baggins@pld-linux.org> cfe7065
- up to 1.9.1

* Fri Jun 09 2017 Jakub Bogusz <qboosh@pld-linux.org> b5a3539
- contains raw_spacetime META file when built with ocaml 4.04 on x86_64

* Fri Jun 09 2017 Jakub Bogusz <qboosh@pld-linux.org> c7e9c63
- updated to 1.7.3
- removed obsolete man patch
- drop ocamlbuild META file (now provided by separate ocaml-ocamlbuild package)
- libexec and stublibs symlinks are back, ocaml-curses is fixed now

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> defaaeb
- rebuild with ocaml 4.04.1
- release 3 (by relup.sh)

* Thu Mar 23 2017 Mariusz Mazur <mmazur@axeos.com> 9be5e17
- rel 2

* Thu Apr 14 2016 Jakub Bogusz <qboosh@pld-linux.org> 343c6db
- updated to 1.6.2
- added man patch (fixes man3,man5 pages install)

* Fri Mar 18 2016 Jan Rękorajski <baggins@pld-linux.org> 647ddc5
- release 11 (by relup.sh)

* Sat Aug 01 2015 Jakub Bogusz <qboosh@pld-linux.org> 0154fcb
- dynlinkable modules moved to base; release 10

* Fri Jul 17 2015 Jakub Bogusz <qboosh@pld-linux.org> 7daadaa
- unify ocaml_opt bcond name
- release 9 (ocaml rebuild)

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> af05b9c
- no debug package either when no opt
- rel 8

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 2448db2
- reverse condition
- rel 7

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> a08ae95
- generic nostrip

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> cb6783e
- fixed files for opt build
- don't strip non-opt builds
- rel 6

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 0014a60
- added opt bcond
- rel 5

